local M = {}
local door_sensor = false
local trunk_sensor = false
local hood_sensor = false
local physically_opening = false
local isOnBurglarAlarm = 0
local burglarAlarmVolume = 0
local hazard_was_on = 0
local play_time = 0.355
local timer = -1
local play_time2 = -2
local timer2 = 0
local play_time3 = -2
local timer3 = 1
local one_time = 1
local one_time2 = 1
local one_time4 = 1
local newbeamSpring = -1
local function onInit()
	if one_time4 == 1 then
		BurglarAlarm = sounds.createSoundscapeSound("BurglarAlarm")
		burglarAlarmBlip = sounds.createSoundscapeSound("burglarAlarmBlip")
		silent_bur_alarm = sounds.createSoundscapeSound("silent_bur_alarm")
		horn_bur_alarm = sounds.createSoundscapeSound("horn_bur_alarm")
		burglar_alarm_door_sensor = sounds.createSoundscapeSound("burglar_alarm_door_sensor")
		burglar_alarm_trunk_sensor = sounds.createSoundscapeSound("burglar_alarm_trunk_sensor")
		burglar_alarm_hood_sensor = sounds.createSoundscapeSound("burglar_alarm_hood_sensor")
		burglar_alarm_physically_opening = sounds.createSoundscapeSound("burglar_alarm_physically_opening")
		if burglar_alarm_door_sensor ~= nil then door_sensor = true end
		if burglar_alarm_trunk_sensor ~= nil then trunk_sensor = true end
		if burglar_alarm_hood_sensor ~= nil then hood_sensor = true end
		if burglar_alarm_physically_opening ~= nil then physically_opening = true end
		burAlarmSensitivity = v.data.variables["$bur_alarm_sensitivity_SAliM"].val
		if silent_bur_alarm ~= nil then if horn_bur_alarm ~= nil then play_time2 = v.data.variables["$bur_alarm_horn_t_SAliM"].val play_time3 = v.data.variables["$bur_alarm_horn_f_SAliM"].val end else burglarAlarmVolume = v.data.variables["$bur_alarm_default_vol_SAliM"].val end
	end
	obj:cutSFX(BurglarAlarm) obj:cutSFX(burglarAlarmBlip) electrics.horn(false) electrics.set_warn_signal(false) do_blip = 0 isOnBurglarAlarm = 0 alarmIsPlaying = 0
end
local function init()
onInit(true)
end
local function updateGFX(dt)
if one_time4 == 1 then onInit(true) one_time4 = 0 end
if electrics.values.toggle_doors_burglar_alarm == 1 then
	if electrics.values.wheelspeed < 1 then
		if (electrics.values.engineRunning == 0 or (powertrain.getDevicesByType("electricMotor") ~= {} and electrics.values.rpm < 500)) then
			electrics.values.burglaralarmOff = -1 do_blip = 1
			if isOnBurglarAlarm == 0 then isOnBurglarAlarm = 1 gui.message("Burglar alarm is active")
			else isOnBurglarAlarm = 0 gui.message("Burglar alarm is not active") end
		else gui.message("You should turn off the engine to activate or deactivate burglar alarm") end
	else gui.message("You should stop the car to activate or deactivate burglar alarm") end
	electrics.values.toggle_doors_burglar_alarm = 0
end
if do_blip == 1 then
	hinge_broken = 0 one_time = 1
	obj:cutSFX(BurglarAlarm)
	if alarmIsPlaying == 1 then electrics.horn(false) alarmIsPlaying = 0 end
	if electrics.values.burglaralarmOff == -1 then electrics.set_warn_signal(true) electrics.values.burglaralarmOff = 0 end
	if electrics.values.hazard == 1 then if hazard_was_on ~= 1 then obj:cutSFX(burglarAlarmBlip) obj:setVolume(burglarAlarmBlip, 2) obj:playSFX(burglarAlarmBlip) timer = 0 hazard_was_on = 1 end elseif hazard_was_on == 1 then electrics.set_warn_signal(false) if timer == -1 then do_blip = 0 hazard_was_on = 0 end end
	if timer > play_time then obj:cutSFX(burglarAlarmBlip) timer = -1
	elseif timer ~= -1 then timer = timer + dt end
	currentDamage = beamstate.damage + burAlarmSensitivity
end
for i = 0, tableSizeC(v.data.beams) - 1 do
	local beam = v.data.beams[i]
	if beam.breakGroup ~= nil and string.find(tostring(beam.breakGroup), "latch") ~= nil and string.find(tostring(beam.breakGroup), "_Openable") == nil then
        if string.find(tostring(beam.breakGroup), "hood") ~= nil then
			if one_time == 1 then hoodAlreadyBroken = obj:beamIsBroken(beam.cid) end hoodIsBroken = obj:beamIsBroken(beam.cid)
        elseif (string.find(tostring(beam.breakGroup), "tailgate") ~= nil or string.find(tostring(beam.breakGroup), "trunk") ~= nil) then
			if one_time == 1 then trunkAlreadyBroken = obj:beamIsBroken(beam.cid) end trunkIsBroken = obj:beamIsBroken(beam.cid)
		elseif string.find(tostring(beam.breakGroup), "door") ~= nil then
			if string.find(tostring(beam.breakGroup), "FL") ~= nil or tostring(beam.breakGroup) == "doorlatch_L" then
				if one_time == 1 then default_FL_BS = beam.beamSpring doorFLAlreadyBroken = obj:beamIsBroken(beam.cid) end doorFLIsBroken = obj:beamIsBroken(beam.cid) newbeamSpring = default_FL_BS
			elseif string.find(tostring(beam.breakGroup), "FR") ~= nil or tostring(beam.breakGroup) == "doorlatch_R" then
				if one_time == 1 then default_FR_BS = beam.beamSpring doorFRAlreadyBroken = obj:beamIsBroken(beam.cid) end doorFRIsBroken = obj:beamIsBroken(beam.cid) newbeamSpring = default_FR_BS
			elseif string.find(tostring(beam.breakGroup), "RL") ~= nil then
				if one_time == 1 then default_RL_BS = beam.beamSpring doorRLAlreadyBroken = obj:beamIsBroken(beam.cid) end doorRLIsBroken = obj:beamIsBroken(beam.cid) newbeamSpring = default_RL_BS
			elseif string.find(tostring(beam.breakGroup), "RR") ~= nil then
				if one_time == 1 then default_RR_BS = beam.beamSpring doorRRAlreadyBroken = obj:beamIsBroken(beam.cid) end doorRRIsBroken = obj:beamIsBroken(beam.cid) newbeamSpring = default_RR_BS
			end
			if physically_opening and beam.beamPrecompression == 1 and not obj:beamIsBroken(beam.cid) then
				if isOnBurglarAlarm == 0 and (electrics.values.engineRunning == 0 or (powertrain.getDevicesByType("electricMotor") ~= {} and electrics.values.rpm < 500)) then newbeamSpring = 10000 end
				if newbeamSpring ~= -1 then obj:setBeamSpringDamp(beam.cid, newbeamSpring/10, beam.beamDamp, -1, -1) end
			end
		end
    end
end
one_time = 0
if isOnBurglarAlarm == 1 then
    if physically_opening then electrics.values['trunk'] = 0 electrics.values['hood'] = 0 electrics.values['doorFL'] = 0 electrics.values['doorFR'] = 0 electrics.values['doorRL'] = 0 electrics.values['doorRR'] = 0 end
	if (hoodAlreadyBroken == false and hoodIsBroken and hood_sensor) or
		(trunkAlreadyBroken == false and trunkIsBroken and trunk_sensor) or
		(doorFLAlreadyBroken == false and doorFLIsBroken and door_sensor) or
		(doorFRAlreadyBroken == false and doorFRIsBroken and door_sensor) or
		(doorRLAlreadyBroken == false and doorRLIsBroken and door_sensor) or
		(doorRRAlreadyBroken == false and doorRRIsBroken and door_sensor) then hinge_broken = 1 one_time = 1 end
	if (electrics.values.engineRunning == 0 or (powertrain.getDevicesByType("electricMotor") ~= {} and electrics.values.rpm < 500)) and electrics.values.burglaralarmOff == 0 then
	if beamstate.damage > currentDamage or hinge_broken == 1 then
		electrics.set_warn_signal(true)
		obj:setVolume(BurglarAlarm, burglarAlarmVolume)
		obj:playSFX(BurglarAlarm)
		if timer3 < play_time3 then
			electrics.horn(false)
			timer3 = timer3 + dt
			one_time3 = 1
			one_time2 = 1
		else
			if one_time3 == 1 then timer2 = 0 one_time3 = 0 end
			if timer2 < play_time2 then
				if one_time2 == 1 then electrics.horn(true) one_time2 = 0 end
				timer2 = timer2 + dt
			else timer2 = 1 timer3 = 0 end
		end
		alarmIsPlaying = 1
	else currentDamage = beamstate.damage + burAlarmSensitivity end
	else
		if electrics.values.engineRunning == 1 and not (powertrain.getDevicesByType("electricMotor") ~= {} and electrics.values.rpm < 500) then isOnBurglarAlarm = 0 gui.message("Engine turned on. Doors locked and burglar alarm deactivated.") end
		if alarmIsPlaying == 1 then electrics.set_warn_signal(false) do_blip = 1 else electrics.values.burglaralarmOff = 0 end
	end
elseif electrics.values.engineRunning == 1 then obj:cutSFX(BurglarAlarm) end
end
M.init      = init
M.onInit    = onInit
M.updateGFX = updateGFX
return M